/*
 * $Id: execute.c,v 1.1 1998/08/18 19:01:21 nicb Exp $
 *
 * Csound Linux source execute.c
 *
 * several utilities have a main built in basically always the same
 * way (a main that calls a specific function setting orchestra and
 * score to a standard name); I isolated this in a specific function
 * so that we know where to debug when we need to...
 * 					[nicb@axnet.it]
 */
#include <string.h>
#include "../cs.h"

extern char scorename[];
extern char orchname[];

/*
 * execute - arguments:
 * 	func:	the pointer to the function to execute
 * 	argc, argv: the parameters coming from main's arguments
 */
int
execute(int (*func)(int, char *[]), int argc, char *argv[], const char *sname,
	const char *oname)
{
    strcpy(scorename, sname);
    strcpy(orchname,  oname);
    return (*func)(argc,argv);
}
/*
 * $Log: execute.c,v $
 * Revision 1.1  1998/08/18 19:01:21  nicb
 * [changes by nicb@axnet.it]
 *
 * - added missing aifc.c file (AIFF floating point support)
 * - re-included AIFC calls into sfheader.c
 * - added excute() utility function to run sub-programs
 * - cleaned up sub-programs main code to avoid link problems
 * - re-organized linux code portion of Make files
 * - corrected bug in midi opcodes (referencing to NULL m_chnbp's)
 * - excluded ustub.h (not needed in linux code)
 *
 */
