/*      					 	PVADD.H    */

/******************************************/
/* The applications in this file were     */
/* designed and coded by Richard Karpen   */
/* University of Washington, Seattle 1998 */
/******************************************/


/* In some future version of Csound the below should be put into a */
/* header file read by all pvoc-related units */
#define     PVFRAMSIZE	    1024		/* i.e. max FFT point size */
#define     PVFFTSIZE	    (2*PVFRAMSIZE)	/* 2x for real + imag */
#define     pvfrsiz(p)	    (p->frSiz)
#define     pvffsiz(p)	    (2* p->frSiz)
#define     pvdasiz(p)	    (1 + (p->frSiz)/2)	/* as above, based on	*/
#define     pvfdsiz(p)	    (2 + p->frSiz)	/*  ACTUAL frameSize in use */




#define     MAXBINS         4096
typedef struct {
    OPDS    h;
    float   *rslt, *ktimpnt, *kfmod, *ifilno, *ifn, *ibins, *ibinoffset, *ibinincr;
    MEMFIL	*mfp;
    FUNC *ftp;
    AUXCH   auxch;
    float   *oscphase, *buf;
    float   frPktim, frPrtim, *frPtr, asr;
    long    baseFr, maxFr, frSiz, prFlg, opBpos;
    int maxbin;
} PVADD;

